;*********************************************************************
; BOXOTRIX ~ MIDI-To-Gate Converter                                  *
;*********************************************************************
; (c) 2006 SM-Sound / Seb Francis                                    *
;*********************************************************************
;
; Memory map, and constant declarations
;
;*********************************************************************


;==================================================
; MISC

#DEFINE			_C	STATUS,C
#DEFINE			_Z	STATUS,Z
LSB			EQU	0x0
MSB			EQU	0x7
GATE1			EQU	0x2
GATE2			EQU	0x3



;==================================================
; Memory - bank 0

; Min			EQU	0x0020

; MIDI stuff
MIDI_FLAGS		EQU	0x0030
; bits
WHICH_BYTE		EQU	0x0		; 0 - next data byte is 1st, 1 - next data byte is 2nd
MSG_LEN			EQU	0x1		; message length: 0=2byte 1=3byte

MIDI_MSG_PROCESS_PTR	EQU	0x0031		; pointer to next MIDI message to process
MIDI_MSG_INCOMING_PTR	EQU	0x0032		; pointer to where to write next incoming MIDI message

MIDI_MSG1		EQU	0x0033		; temp buffer for message byte 1
MIDI_MSG2		EQU	0x0034		; temp buffer for message byte 2

MIDI_MSG_BUFFER		EQU	0x0040		; start of MIDI message ring buffer
;				0x0041
;				0x0042
;				0x0043
;				0x0044
;				0x0045
;				0x0046
;				0x0047
;				0x0048
;				0x0049
;				0x004A
;				0x004B
;				0x004C
;				0x004D
;				0x004E
MIDI_MSG_BUFFER_END	EQU	0x004F		; end of MIDI message ring buffer

; Max			EQU	0x005F


; Stuff for fixed point maths routines
; 0x0060-0x006F in bank 0
; 0x00E0-0x00EF in bank 1
; 0x0160-0x016F in bank 2
AARGB2			EQU	0x0060		; argument A, LSB
AARGB1			EQU	0x0061		; argument A
AARGB0			EQU	0x0062		; argument A, MSB
BARGB1			EQU	0x0063		; argument B, LSB
BARGB0			EQU	0x0064		; argument B, MSB
REMB1			EQU	0x0065		; remainder LSB
REMB0			EQU	0x0066		; remainder MSB
TEMP			EQU	0x0067
TEMPB3			EQU	0x0068
TEMPB1			EQU	0x0069
TEMPB0			EQU	0x006A
SIGN			EQU	0x006B
LOOPCOUNT		EQU	0x006C
FPFLAGS			EQU	0x006D
; bits
NAN			EQU	0x0


; Memory accessible in all banks

W_TEMP        		EQU     0x0070        	; variable used for context saving
STATUS_TEMP		EQU	0x0071		; variable used for context saving
PCLATH_TEMP		EQU	0x0072		; variable used for context saving
FSR_TEMP		EQU	0x0073		; variable used for context saving
COUNTER			EQU	0x0074		; counter for loops
TEMP1			EQU	0x0075		; general purpose temp variable
TEMP2			EQU	0x0076		; general purpose temp variable
TEMP3			EQU	0x0077		; general purpose temp variable
TEMP4			EQU	0x0078		; general purpose temp variable
TEMP5			EQU	0x0079		; general purpose temp variable

; Temp vars for main loop
MTEMP1			EQU	0x007A
MTEMP2			EQU	0x007B
MTEMP3			EQU	0x007C
MTEMP4			EQU	0x007D
MTEMP5			EQU	0x007E

; Max			EQU	0x007F


;==================================================
; Memory - bank 1

; Min			EQU	0x00A0

; Max			EQU	0x00DF

; Stuff for fixed point maths routines
; 0x0060-0x006F in bank 0
; 0x00E0-0x00EF in bank 1
; 0x0160-0x016F in bank 2


;==================================================
; Memory - bank 2

; Min			EQU	0x0120

; Max			EQU	0x015F

; Stuff for fixed point maths routines
; 0x0060-0x006F in bank 0
; 0x00E0-0x00EF in bank 1
; 0x0160-0x016F in bank 2

;==================================================
